core118: Reload apache to make configuration changes take effect
[ipfire-2.x.git] / make.sh
CommitLineData
df5e82b3 1#!/bin/bash
df5e82b3
MT
2############################################################################
3# #
f8e5510c 4# This file is part of the IPFire Firewall. #
df5e82b3 5# #
f8e5510c 6# IPFire is free software; you can redistribute it and/or modify #
df5e82b3
MT
7# it under the terms of the GNU General Public License as published by #
8# the Free Software Foundation; either version 2 of the License, or #
9# (at your option) any later version. #
10# #
f8e5510c 11# IPFire is distributed in the hope that it will be useful, #
df5e82b3
MT
12# but WITHOUT ANY WARRANTY; without even the implied warranty of #
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14# GNU General Public License for more details. #
15# #
16# You should have received a copy of the GNU General Public License #
f8e5510c 17# along with IPFire; if not, write to the Free Software #
df5e82b3
MT
18# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19# #
f7a48dd3 20# Copyright (C) 2007-2017 IPFire Team <info@ipfire.org>. #
df5e82b3
MT
21# #
22############################################################################
df5e82b3
MT
23#
24
e8ee3199
AF
25NAME="IPFire" # Software name
26SNAME="ipfire" # Short name
33513817 27VERSION="2.19" # Version number
1068c3e7 28CORE="118" # Core Level (Filename)
9559fb08 29PAKFIRE_CORE="117" # Core Level (PAKFIRE)
595e89a8 30GIT_BRANCH=`git rev-parse --abbrev-ref HEAD` # Git Branch
e8ee3199
AF
31SLOGAN="www.ipfire.org" # Software slogan
32CONFIG_ROOT=/var/ipfire # Configuration rootdir
33NICE=10 # Nice level
34MAX_RETRIES=1 # prefetch/check loop
305a7b38 35BUILD_IMAGES=1 # Flash and Xen Downloader
15679d9f 36KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
e8ee3199
AF
37GIT_TAG=$(git tag | tail -1) # Git Tag
38GIT_LASTCOMMIT=$(git log | head -n1 | cut -d" " -f2 |head -c8) # Last commit
628e8c3a 39
6c4cc7ea 40TOOLCHAINVER=20171121
03ad5f93 41
69a6ec55
MT
42###############################################################################
43#
44# Beautifying variables & presentation & input output interface
45#
46###############################################################################
47
f9783277
MT
48# Remember if the shell is interactive or not
49if [ -t 0 ] && [ -t 1 ]; then
50 INTERACTIVE=true
51else
52 INTERACTIVE=false
53fi
54
401a1edc
MT
55# Sets or adjusts pretty formatting variables
56resize_terminal() {
57 ## Screen Dimentions
58 # Find current screen size
59 COLUMNS=$(tput cols)
60
61 # When using remote connections, such as a serial port, stty size returns 0
62 if ! ${INTERACTIVE} || [ "${COLUMNS}" = "0" ]; then
63 COLUMNS=80
64 fi
69a6ec55 65
401a1edc
MT
66 # Measurements for positioning result messages
67 OPTIONS_WIDTH=20
68 TIME_WIDTH=12
69 STATUS_WIDTH=8
70 NAME_WIDTH=$(( COLUMNS - OPTIONS_WIDTH - TIME_WIDTH - STATUS_WIDTH ))
71 LINE_WIDTH=$(( COLUMNS - STATUS_WIDTH ))
72
e9a57acd
MT
73 TIME_COL=$(( NAME_WIDTH + OPTIONS_WIDTH ))
74 STATUS_COL=$(( TIME_COL + TIME_WIDTH ))
401a1edc 75}
69a6ec55 76
401a1edc
MT
77# Initially setup terminal
78resize_terminal
f9783277 79
401a1edc
MT
80# Call resize_terminal when terminal is being resized
81trap "resize_terminal" WINCH
69a6ec55
MT
82
83# Define color for messages
84BOLD="\\033[1;39m"
85DONE="\\033[1;32m"
86SKIP="\\033[1;34m"
87WARN="\\033[1;35m"
88FAIL="\\033[1;31m"
89NORMAL="\\033[0;39m"
90
bcb9dc13 91# New architecture variables
dc7d6b20 92HOST_ARCH="$(uname -m)"
94571564 93
69a6ec55
MT
94PWD=$(pwd)
95BASENAME=$(basename $0)
96
15679d9f
MT
97# Debian specific settings
98if [ ! -e /etc/debian_version ]; then
df5e82b3 99 FULLPATH=`which $0`
15679d9f 100else
df5e82b3
MT
101 if [ -x /usr/bin/realpath ]; then
102 FULLPATH=`/usr/bin/realpath $0`
103 else
104 echo "ERROR: Need to do apt-get install realpath"
105 exit 1
106 fi
15679d9f 107fi
df5e82b3 108
69a6ec55 109# This is the directory where make.sh is in
aecbe123 110export BASEDIR=$(echo $FULLPATH | sed "s/\/$BASENAME//g")
69a6ec55 111
15679d9f 112LOGFILE=$BASEDIR/log/_build.preparation.log
aecbe123 113export LOGFILE
15679d9f
MT
114DIR_CHK=$BASEDIR/cache/check
115mkdir $BASEDIR/log/ 2>/dev/null
df5e82b3 116
69a6ec55
MT
117system_processors() {
118 getconf _NPROCESSORS_ONLN 2>/dev/null || echo "1"
119}
120
121system_memory() {
122 local key val unit
123
124 while read -r key val unit; do
125 case "${key}" in
126 MemTotal:*)
127 # Convert to MB
128 echo "$(( ${val} / 1024 ))"
129 break
130 ;;
131 esac
132 done < /proc/meminfo
133}
134
135configure_build() {
136 local build_arch="${1}"
137
138 if [ "${build_arch}" = "default" ]; then
139 build_arch="$(configure_build_guess)"
140 fi
141
142 case "${build_arch}" in
143 x86_64)
144 BUILDTARGET="${build_arch}-unknown-linux-gnu"
145 CROSSTARGET="${build_arch}-cross-linux-gnu"
146 BUILD_PLATFORM="x86"
147 CFLAGS_ARCH="-m64 -mtune=generic"
148 ;;
149
150 i586)
151 BUILDTARGET="${build_arch}-pc-linux-gnu"
152 CROSSTARGET="${build_arch}-cross-linux-gnu"
153 BUILD_PLATFORM="x86"
154 CFLAGS_ARCH="-march=i586 -mtune=generic -fomit-frame-pointer"
155 ;;
156
157 aarch64)
158 BUILDTARGET="${build_arch}-unknown-linux-gnu"
159 CROSSTARGET="${build_arch}-cross-linux-gnu"
160 BUILD_PLATFORM="arm"
161 CFLAGS_ARCH=""
162 ;;
163
164 armv7hl)
165 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
166 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
167 BUILD_PLATFORM="arm"
168 CFLAGS_ARCH="-march=armv7-a -mfpu=vfpv3-d16 -mfloat-abi=hard"
169 ;;
170
171 armv5tel)
172 BUILDTARGET="${build_arch}-unknown-linux-gnueabi"
173 CROSSTARGET="${build_arch}-cross-linux-gnueabi"
174 BUILD_PLATFORM="arm"
175 CFLAGS_ARCH="-march=armv5te -mfloat-abi=soft -fomit-frame-pointer"
176 ;;
177
178 *)
179 exiterror "Cannot build for architure ${build_arch}"
180 ;;
181 esac
182
183 # Check if the QEMU helper is available if needed.
184 if qemu_is_required "${build_arch}"; then
185 local qemu_build_helper="$(qemu_find_build_helper_name "${build_arch}")"
186
187 if [ -n "${qemu_build_helper}" ]; then
188 QEMU_TARGET_HELPER="${qemu_build_helper}"
189 else
190 exiterror "Could not find a binfmt_misc helper entry for ${build_arch}"
191 fi
192 fi
193
194 BUILD_ARCH="${build_arch}"
195 TOOLS_DIR="/tools_${BUILD_ARCH}"
196
197 # Enables hardening
198 HARDENING_CFLAGS="-Wp,-D_FORTIFY_SOURCE=2 -fstack-protector-strong --param=ssp-buffer-size=4"
199
200 CFLAGS="-O2 -pipe -Wall -fexceptions -fPIC ${CFLAGS_ARCH}"
201 CXXFLAGS="${CFLAGS}"
202
203 # Determine parallelism
204 if [ -z "${MAKETUNING}" ]; then
205 # We assume that each process consumes about
206 # 192MB of memory. Therefore we find out how
207 # many processes fit into memory.
208 local mem_max=$(( ${HOST_MEM} / 192 ))
209
210 local processors="$(system_processors)"
211 local cpu_max=$(( ${processors} * 2 ))
212
213 local parallelism
214 if [ ${mem_max} -lt ${cpu_max} ]; then
215 parallelism=${mem_max}
216 else
217 parallelism=${cpu_max}
218 fi
219
979f8700
AF
220 # limit to -j23 because perl will not build
221 # more
222 if [ ${parallelism} -gt 23 ]; then
223 parallelism=23
224 fi
225
69a6ec55
MT
226 MAKETUNING="-j${parallelism}"
227 fi
228}
229
230configure_build_guess() {
231 case "${HOST_ARCH}" in
232 x86_64|i686|i586)
233 echo "i586"
234 ;;
235
236 aarch64)
237 echo "aarch64"
238 ;;
239
240 armv7*|armv6*|armv5*)
241 echo "armv5tel"
242 ;;
243
244 *)
245 exiterror "Cannot guess build architecture"
246 ;;
247 esac
248}
249
f9783277
MT
250stdumount() {
251 umount $BASEDIR/build/sys 2>/dev/null;
252 umount $BASEDIR/build/dev/shm 2>/dev/null;
253 umount $BASEDIR/build/dev/pts 2>/dev/null;
254 umount $BASEDIR/build/dev 2>/dev/null;
255 umount $BASEDIR/build/proc 2>/dev/null;
256 umount $BASEDIR/build/install/mnt 2>/dev/null;
257 umount $BASEDIR/build/usr/src/cache 2>/dev/null;
258 umount $BASEDIR/build/usr/src/ccache 2>/dev/null;
259 umount $BASEDIR/build/usr/src/config 2>/dev/null;
260 umount $BASEDIR/build/usr/src/doc 2>/dev/null;
261 umount $BASEDIR/build/usr/src/html 2>/dev/null;
262 umount $BASEDIR/build/usr/src/langs 2>/dev/null;
263 umount $BASEDIR/build/usr/src/lfs 2>/dev/null;
264 umount $BASEDIR/build/usr/src/log 2>/dev/null;
265 umount $BASEDIR/build/usr/src/src 2>/dev/null;
266}
267
268now() {
269 date -u "+%s"
69a6ec55
MT
270}
271
f9783277
MT
272format_runtime() {
273 local seconds=${1}
274
275 if [ ${seconds} -ge 3600 ]; then
276 printf "%d:%02d:%02d\n" \
277 "$(( seconds / 3600 ))" \
278 "$(( seconds % 3600 / 60 ))" \
279 "$(( seconds % 3600 % 60 ))"
280 elif [ ${seconds} -ge 60 ]; then
281 printf "%d:%02d\n" \
282 "$(( seconds / 60 ))" \
283 "$(( seconds % 60 ))"
69a6ec55 284 else
f9783277 285 printf "%d\n" "${seconds}"
69a6ec55 286 fi
f9783277 287}
69a6ec55 288
f9783277
MT
289print_line() {
290 local line="$@"
69a6ec55 291
f9783277 292 printf "%-${LINE_WIDTH}s" "${line}"
69a6ec55
MT
293}
294
f9783277
MT
295_print_line() {
296 local status="${1}"
297 shift
69a6ec55 298
f9783277
MT
299 if ${INTERACTIVE}; then
300 printf "${!status}"
301 fi
69a6ec55 302
f9783277
MT
303 print_line "$@"
304
305 if ${INTERACTIVE}; then
306 printf "${NORMAL}"
307 fi
308}
309
310print_headline() {
311 _print_line BOLD "$@"
69a6ec55
MT
312}
313
f9783277
MT
314print_error() {
315 _print_line FAIL "$@"
316}
317
318print_package() {
319 local name="${1}"
320 shift
69a6ec55 321
f9783277
MT
322 local version="$(grep -E "^VER |^VER=|^VER " $BASEDIR/lfs/${name} | awk '{ print $3 }')"
323 local options="$@"
324
325 local string="${name}"
326 if [ -n "${version}" ] && [ "${version}" != "ipfire" ]; then
327 string="${string} (${version})"
328 fi
329
330 printf "%-$(( ${NAME_WIDTH} - 1 ))s " "${string}"
fa8c758e 331 printf "%$(( ${OPTIONS_WIDTH} - 1 ))s " "${options}"
f9783277
MT
332}
333
334print_runtime() {
335 local runtime=$(format_runtime $@)
336
337 if ${INTERACTIVE}; then
338 printf "\\033[${TIME_COL}G[ ${BOLD}%$(( ${TIME_WIDTH} - 4 ))s${NORMAL} ]" "${runtime}"
339 else
340 printf "[ %$(( ${TIME_WIDTH} - 4 ))s ]" "${runtime}"
69a6ec55 341 fi
f9783277
MT
342}
343
344print_status() {
345 local status="${1}"
346
347 local color="${!status}"
348
349 if ${INTERACTIVE}; then
350 printf "\\033[${STATUS_COL}G[${color-${BOLD}} %-$(( ${STATUS_WIDTH} - 4 ))s ${NORMAL}]\n" "${status}"
351 else
352 printf "[ %-$(( ${STATUS_WIDTH} - 4 ))s ]\n" "${status}"
69a6ec55 353 fi
f9783277 354}
69a6ec55 355
f9783277
MT
356print_build_stage() {
357 print_headline "$@"
358
359 # end line
360 printf "\n"
69a6ec55
MT
361}
362
f9783277
MT
363print_build_summary() {
364 local runtime=$(format_runtime $@)
365
366 print_line "*** Build finished in ${runtime}"
367 print_status DONE
69a6ec55
MT
368}
369
370exiterror() {
371 stdumount
372 for i in `seq 0 7`; do
373 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
374 losetup -d /dev/loop${i} 2>/dev/null
375 fi;
376 done
377
f9783277 378 # Dump logfile
66028310 379 if [ -n "${LOGFILE}" ] && [ -e "${LOGFILE}" ]; then
69a6ec55
MT
380 echo # empty line
381
382 local line
383 while read -r line; do
384 echo " ${line}"
385 done <<< "$(tail -n30 ${LOGFILE})"
386 fi
387
f9783277
MT
388 echo # empty line
389
390 local line
391 for line in "ERROR: $@" " Check ${LOGFILE} for errors if applicable"; do
392 print_error "${line}"
393 print_status FAIL
394 done
395
69a6ec55
MT
396 exit 1
397}
398
aecbe123
MT
399prepareenv() {
400 # Are we running the right shell?
54328605 401 if [ -z "${BASH}" ]; then
aecbe123
MT
402 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
403 fi
404
405 if [ -z "${BASH_VERSION}" ]; then
406 exiterror "Not running BASH shell."
407 fi
408
409 # Trap on emergency exit
410 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
411
412 # Resetting our nice level
658232a6 413 if ! renice ${NICE} $$ >/dev/null; then
658232a6 414 exiterror "Failed to set nice level to ${NICE}"
aecbe123
MT
415 fi
416
417 # Checking if running as root user
658232a6 418 if [ $(id -u) -ne 0 ]; then
aecbe123 419 exiterror "Not building as root"
aecbe123
MT
420 fi
421
422 # Checking for necessary temporary space
f9783277 423 print_line "Checking for necessary space on disk $BASE_DEV"
aecbe123
MT
424 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
425 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
426 if (( 2048000 > $BASE_ASPACE )); then
427 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
428 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
f9783277 429 print_status FAIL
aecbe123
MT
430 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
431 fi
432 else
f9783277 433 print_status DONE
aecbe123
MT
434 fi
435
436 # Set umask
437 umask 022
438
439 # Set LFS Directory
440 LFS=$BASEDIR/build
441
aecbe123
MT
442 # Setup environment
443 set +h
444 LC_ALL=POSIX
445 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
446 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
447
448 # Make some extra directories
449 mkdir -p "${BASEDIR}/build${TOOLS_DIR}" 2>/dev/null
450 mkdir -p $BASEDIR/build/{etc,usr/src} 2>/dev/null
451 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
452 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
453 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
454
455 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
456 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
457
458 # Make all sources and proc available under lfs build
459 mount --bind /dev $BASEDIR/build/dev
460 mount --bind /dev/pts $BASEDIR/build/dev/pts
461 mount --bind /dev/shm $BASEDIR/build/dev/shm
462 mount --bind /proc $BASEDIR/build/proc
463 mount --bind /sys $BASEDIR/build/sys
464 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
465 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
466 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
467 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
468 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
469 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
470 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
471 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
472 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
473
474 # Run LFS static binary creation scripts one by one
475 export CCACHE_DIR=$BASEDIR/ccache
476 export CCACHE_COMPRESS=1
477 export CCACHE_COMPILERCHECK="string:toolchain-${TOOLCHAINVER} ${BUILD_ARCH}"
478
479 # Remove pre-install list of installed files in case user erase some files before rebuild
480 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
481
482 # Prepare string for /etc/system-release.
483 SYSTEM_RELEASE="${NAME} ${VERSION} (${BUILD_ARCH})"
484 if [ "$(git status -s | wc -l)" == "0" ]; then
485 GIT_STATUS=""
486 else
487 GIT_STATUS="-dirty"
488 fi
489 case "$GIT_BRANCH" in
490 core*|beta?|rc?)
491 SYSTEM_RELEASE="${SYSTEM_RELEASE} - $GIT_BRANCH$GIT_STATUS"
492 ;;
493 *)
494 SYSTEM_RELEASE="${SYSTEM_RELEASE} - Development Build: $GIT_BRANCH/$GIT_LASTCOMMIT$GIT_STATUS"
495 ;;
496 esac
497}
498
69a6ec55
MT
499enterchroot() {
500 # Install QEMU helper, if needed
501 qemu_install_helper
502
503 local PATH="${TOOLS_DIR}/ccache/bin:/bin:/usr/bin:/sbin:/usr/sbin:${TOOLS_DIR}/bin"
504
505 PATH="${PATH}" chroot ${LFS} env -i \
506 HOME="/root" \
507 TERM="${TERM}" \
508 PS1="${PS1}" \
509 PATH="${PATH}" \
510 SYSTEM_RELEASE="${SYSTEM_RELEASE}" \
511 PAKFIRE_CORE="${PAKFIRE_CORE}" \
512 NAME="${NAME}" \
513 SNAME="${SNAME}" \
514 VERSION="${VERSION}" \
515 CORE="${CORE}" \
516 SLOGAN="${SLOGAN}" \
517 TOOLS_DIR="${TOOLS_DIR}" \
518 CONFIG_ROOT="${CONFIG_ROOT}" \
519 CFLAGS="${CFLAGS} ${HARDENING_CFLAGS}" \
520 CXXFLAGS="${CXXFLAGS} ${HARDENING_CFLAGS}" \
521 BUILDTARGET="${BUILDTARGET}" \
522 CROSSTARGET="${CROSSTARGET}" \
523 BUILD_ARCH="${BUILD_ARCH}" \
524 BUILD_PLATFORM="${BUILD_PLATFORM}" \
525 CCACHE_DIR=/usr/src/ccache \
526 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
527 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
528 KVER="${KVER}" \
529 $(fake_environ) \
530 $(qemu_environ) \
531 "$@"
532}
533
534entershell() {
535 if [ ! -e $BASEDIR/build/usr/src/lfs/ ]; then
536 exiterror "No such file or directory: $BASEDIR/build/usr/src/lfs/"
537 fi
538
539 echo "Entering to a shell inside LFS chroot, go out with exit"
540 local PS1="ipfire build chroot ($(uname -m)) \u:\w\$ "
541
542 if enterchroot bash -i; then
543 stdumount
544 else
f9783277 545 print_status FAIL
69a6ec55
MT
546 exiterror "chroot error"
547 fi
548}
549
550lfsmakecommoncheck() {
551 # Script present?
552 if [ ! -f $BASEDIR/lfs/$1 ]; then
553 exiterror "No such file or directory: $BASEDIR/$1"
554 fi
555
f9783277
MT
556 # Print package name and version
557 print_package $@
69a6ec55
MT
558
559 # Check if this package is supported by our architecture.
560 # If no SUP_ARCH is found, we assume the package can be built for all.
561 if grep "^SUP_ARCH" ${BASEDIR}/lfs/${1} >/dev/null; then
562 # Check if package supports ${BUILD_ARCH} or all architectures.
563 if ! grep -E "^SUP_ARCH.*${BUILD_ARCH}|^SUP_ARCH.*all" ${BASEDIR}/lfs/${1} >/dev/null; then
405ee2b4 564 print_runtime 0
f9783277 565 print_status SKIP
69a6ec55
MT
566 return 1
567 fi
568 fi
569
570 # Script slipped?
571 local i
572 for i in $SKIP_PACKAGE_LIST
573 do
574 if [ "$i" == "$1" ]; then
f9783277 575 print_status SKIP
69a6ec55
MT
576 return 1;
577 fi
578 done
579
580 echo -ne "`date -u '+%b %e %T'`: Building $* " >> $LOGFILE
581
582 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
583 MESSAGE="$1\t " download >> $LOGFILE 2>&1
584 if [ $? -ne 0 ]; then
585 exiterror "Download error in $1"
586 fi
587
588 cd $BASEDIR/lfs && make -s -f $* LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
589 MESSAGE="$1\t md5sum" md5 >> $LOGFILE 2>&1
590 if [ $? -ne 0 ]; then
591 exiterror "md5sum error in $1, check file in cache or signature"
592 fi
593
594 return 0 # pass all!
595}
596
597lfsmake1() {
598 lfsmakecommoncheck $*
599 [ $? == 1 ] && return 0
600
69a6ec55
MT
601 cd $BASEDIR/lfs && env -i \
602 PATH="${TOOLS_DIR}/ccache/bin:${TOOLS_DIR}/bin:$PATH" \
603 CCACHE_DIR="${CCACHE_DIR}" \
604 CCACHE_COMPRESS="${CCACHE_COMPRESS}" \
605 CCACHE_COMPILERCHECK="${CCACHE_COMPILERCHECK}" \
606 CFLAGS="${CFLAGS}" \
607 CXXFLAGS="${CXXFLAGS}" \
608 MAKETUNING="${MAKETUNING}" \
609 make -f $* \
610 TOOLCHAIN=1 \
611 TOOLS_DIR="${TOOLS_DIR}" \
612 CROSSTARGET="${CROSSTARGET}" \
613 BUILDTARGET="${BUILDTARGET}" \
614 BUILD_ARCH="${BUILD_ARCH}" \
615 BUILD_PLATFORM="${BUILD_PLATFORM}" \
616 LFS_BASEDIR="${BASEDIR}" \
617 ROOT="${LFS}" \
618 KVER="${KVER}" \
f9783277 619 install >> $LOGFILE 2>&1 &
69a6ec55 620
f9783277
MT
621 if ! wait_until_finished $!; then
622 print_status FAIL
623 exiterror "Building $*"
69a6ec55
MT
624 fi
625
f9783277 626 print_status DONE
69a6ec55
MT
627}
628
629lfsmake2() {
630 lfsmakecommoncheck $*
631 [ $? == 1 ] && return 0
632
69a6ec55
MT
633 local PS1='\u:\w$ '
634
635 enterchroot \
ce9264a1 636 ${EXTRA_PATH}bash -x -c "cd /usr/src/lfs && \
69a6ec55
MT
637 MAKETUNING=${MAKETUNING} \
638 make -f $* \
639 LFS_BASEDIR=/usr/src install" \
f9783277 640 >> ${LOGFILE} 2>&1 &
69a6ec55 641
f9783277
MT
642 if ! wait_until_finished $!; then
643 print_status FAIL
644 exiterror "Building $*"
69a6ec55
MT
645 fi
646
f9783277 647 print_status DONE
69a6ec55
MT
648}
649
650ipfiredist() {
651 lfsmakecommoncheck $*
652 [ $? == 1 ] && return 0
653
69a6ec55
MT
654 local PS1='\u:\w$ '
655
656 enterchroot \
657 bash -x -c "cd /usr/src/lfs && make -f $* LFS_BASEDIR=/usr/src dist" \
f9783277 658 >> ${LOGFILE} 2>&1 &
69a6ec55 659
f9783277
MT
660 if ! wait_until_finished $!; then
661 print_status FAIL
662 exiterror "Packaging $*"
663 fi
69a6ec55 664
f9783277
MT
665 print_status DONE
666}
667
668wait_until_finished() {
669 local pid=${1}
670
671 local start_time=$(now)
672
673 # Show progress
674 if ${INTERACTIVE}; then
675 # Wait a little just in case the process
676 # has finished very quickly.
677 sleep 0.1
678
679 local runtime
680 while kill -0 ${pid} 2>/dev/null; do
681 print_runtime $(( $(now) - ${start_time} ))
682
683 # Wait a little
684 sleep 1
685 done
69a6ec55 686 fi
f9783277
MT
687
688 # Returns the exit code of the child process
689 wait ${pid}
690 local ret=$?
691
692 if ! ${INTERACTIVE}; then
693 print_runtime $(( $(now) - ${start_time} ))
694 fi
695
696 return ${ret}
69a6ec55
MT
697}
698
699fake_environ() {
700 [ -e "${BASEDIR}/build${TOOLS_DIR}/lib/libpakfire_preload.so" ] || return
701
702 local env="LD_PRELOAD=${TOOLS_DIR}/lib/libpakfire_preload.so"
703
704 # Fake kernel version, because some of the packages do not compile
705 # with kernel 3.0 and later.
706 env="${env} UTS_RELEASE=${KVER}"
707
708 # Fake machine version.
709 env="${env} UTS_MACHINE=${BUILD_ARCH}"
710
711 echo "${env}"
712}
713
714qemu_environ() {
715 local env
716
717 # Don't add anything if qemu is not used.
718 if ! qemu_is_required; then
719 return
720 fi
721
722 # Set default qemu options
723 case "${BUILD_ARCH}" in
724 arm*)
725 QEMU_CPU="${QEMU_CPU:-cortex-a9}"
726
727 env="${env} QEMU_CPU=${QEMU_CPU}"
728 ;;
729 esac
730
731 # Enable QEMU strace
732 #env="${env} QEMU_STRACE=1"
733
734 echo "${env}"
735}
736
737qemu_is_required() {
738 local build_arch="${1}"
739
740 if [ -z "${build_arch}" ]; then
741 build_arch="${BUILD_ARCH}"
742 fi
743
744 case "${HOST_ARCH},${build_arch}" in
745 x86_64,arm*|i?86,arm*|i?86,x86_64)
746 return 0
747 ;;
748 *)
749 return 1
750 ;;
751 esac
752}
753
754qemu_install_helper() {
755 # Do nothing, if qemu is not required
756 if ! qemu_is_required; then
757 return 0
758 fi
759
760 if [ ! -e /proc/sys/fs/binfmt_misc/status ]; then
761 exiterror "binfmt_misc not mounted. QEMU_TARGET_HELPER not useable."
762 fi
763
764 if [ ! $(cat /proc/sys/fs/binfmt_misc/status) = 'enabled' ]; then
765 exiterror "binfmt_misc not enabled. QEMU_TARGET_HELPER not useable."
766 fi
767
768
769 if [ -z "${QEMU_TARGET_HELPER}" ]; then
770 exiterror "QEMU_TARGET_HELPER not set"
771 fi
772
773 # Check if the helper is already installed.
774 if [ -x "${LFS}${QEMU_TARGET_HELPER}" ]; then
775 return 0
776 fi
777
778 # Try to find a suitable binary that we can install
779 # to the build environment.
780 local file
781 for file in "${QEMU_TARGET_HELPER}" "${QEMU_TARGET_HELPER}-static"; do
782 # file must exist and be executable.
783 [ -x "${file}" ] || continue
784
785 # Must be static.
786 file_is_static "${file}" || continue
787
788 local dirname="${LFS}$(dirname "${file}")"
789 mkdir -p "${dirname}"
790
791 install -m 755 "${file}" "${LFS}${QEMU_TARGET_HELPER}"
792 return 0
793 done
794
795 exiterror "Could not find a statically-linked QEMU emulator: ${QEMU_TARGET_HELPER}"
796}
797
798qemu_find_build_helper_name() {
799 local build_arch="${1}"
800
801 local magic
802 case "${build_arch}" in
803 arm*)
804 magic="7f454c4601010100000000000000000002002800"
805 ;;
806 x86_64)
807 magic="7f454c4602010100000000000000000002003e00"
808 ;;
809 esac
810
811 [ -z "${magic}" ] && return 1
812
813 local file
814 for file in /proc/sys/fs/binfmt_misc/*; do
815 # skip write only register entry
816 [ $(basename "${file}") = "register" ] && continue
817 # Search for the file with the correct magic value.
818 grep -qE "^magic ${magic}$" "${file}" || continue
819
820 local interpreter="$(grep "^interpreter" "${file}" | awk '{ print $2 }')"
821
822 [ -n "${interpreter}" ] || continue
823 [ "${interpreter:0:1}" = "/" ] || continue
824 [ -x "${interpreter}" ] || continue
825
826 echo "${interpreter}"
827 return 0
828 done
829
830 return 1
831}
832
833file_is_static() {
834 local file="${1}"
835
836 file ${file} 2>/dev/null | grep -q "statically linked"
837}
838
839update_language_list() {
840 local path="${1}"
841
842 local lang
843 for lang in ${path}/*.po; do
844 lang="$(basename "${lang}")"
845 echo "${lang%*.po}"
846 done | sort -u > "${path}/LINGUAS"
847}
848
a98ab1d7
MT
849# Load configuration file
850if [ -f .config ]; then
851 . .config
852fi
853
813659f2
MT
854# TARGET_ARCH is BUILD_ARCH now
855if [ -n "${TARGET_ARCH}" ]; then
856 BUILD_ARCH="${TARGET_ARCH}"
857 unset TARGET_ARCH
858fi
859
5190eea2
MT
860# Get the amount of memory in this build system
861HOST_MEM=$(system_memory)
862
dc7d6b20
MT
863if [ -n "${BUILD_ARCH}" ]; then
864 configure_build "${BUILD_ARCH}"
949544f5 865else
dc7d6b20 866 configure_build "default"
949544f5
MT
867fi
868
df5e82b3 869buildtoolchain() {
69a6ec55
MT
870 local error=false
871 case "${BUILD_ARCH}:${HOST_ARCH}" in
872 # x86_64
873 x86_64:x86_64)
874 # This is working.
875 ;;
876
877 # x86
878 i586:i586|i586:i686|i586:x86_64)
879 # These are working.
880 ;;
881 i586:*)
882 error=true
883 ;;
884
885 # ARM
886 arvm7hl:armv7hl|armv7hl:armv7l)
887 # These are working.
888 ;;
889
890 armv5tel:armv5tel|armv5tel:armv5tejl|armv5tel:armv6l|armv5tel:armv7l|armv5tel:aarch64)
891 # These are working.
892 ;;
893 armv5tel:*)
894 error=true
895 ;;
896 esac
897
898 ${error} && \
899 exiterror "Cannot build ${BUILD_ARCH} toolchain on $(uname -m). Please use the download if any."
900
901 local gcc=$(type -p gcc)
902 if [ -z "${gcc}" ]; then
903 exiterror "Could not find GCC. You will need a working build enviroment in order to build the toolchain."
904 fi
905
6bd3a131
MT
906 # Check ${TOOLS_DIR} symlink
907 if [ -h "${TOOLS_DIR}" ]; then
908 rm -f "${TOOLS_DIR}"
909 fi
910
911 if [ ! -e "${TOOLS_DIR}" ]; then
912 ln -s "${BASEDIR}/build${TOOLS_DIR}" "${TOOLS_DIR}"
913 fi
914
915 if [ ! -h "${TOOLS_DIR}" ]; then
916 exiterror "Could not create ${TOOLS_DIR} symbolic link"
917 fi
918
69a6ec55
MT
919 LOGFILE="$BASEDIR/log/_build.toolchain.log"
920 export LOGFILE
921
922 lfsmake1 stage1
923 lfsmake1 ccache PASS=1
924 lfsmake1 binutils PASS=1
925 lfsmake1 gcc PASS=1
926 lfsmake1 linux KCFG="-headers"
927 lfsmake1 glibc
928 lfsmake1 gcc PASS=L
929 lfsmake1 binutils PASS=2
930 lfsmake1 gcc PASS=2
931 lfsmake1 ccache PASS=2
932 lfsmake1 tcl
933 lfsmake1 expect
934 lfsmake1 dejagnu
935 lfsmake1 pkg-config
936 lfsmake1 ncurses
937 lfsmake1 bash
938 lfsmake1 bzip2
939 lfsmake1 automake
940 lfsmake1 coreutils
941 lfsmake1 diffutils
942 lfsmake1 findutils
943 lfsmake1 gawk
944 lfsmake1 gettext
945 lfsmake1 grep
946 lfsmake1 gzip
947 lfsmake1 m4
948 lfsmake1 make
949 lfsmake1 patch
950 lfsmake1 perl
951 lfsmake1 sed
952 lfsmake1 tar
953 lfsmake1 texinfo
954 lfsmake1 xz
955 lfsmake1 fake-environ
7b93b62b 956 lfsmake1 strip
69a6ec55 957 lfsmake1 cleanup-toolchain
df5e82b3
MT
958}
959
960buildbase() {
69a6ec55
MT
961 LOGFILE="$BASEDIR/log/_build.base.log"
962 export LOGFILE
963 lfsmake2 stage2
964 lfsmake2 linux KCFG="-headers"
965 lfsmake2 man-pages
966 lfsmake2 glibc
967 lfsmake2 tzdata
968 lfsmake2 cleanup-toolchain
969 lfsmake2 zlib
970 lfsmake2 binutils
971 lfsmake2 gmp
972 lfsmake2 gmp-compat
973 lfsmake2 mpfr
974 lfsmake2 libmpc
975 lfsmake2 file
976 lfsmake2 gcc
977 lfsmake2 sed
978 lfsmake2 autoconf
979 lfsmake2 automake
980 lfsmake2 berkeley
981 lfsmake2 coreutils
982 lfsmake2 iana-etc
983 lfsmake2 m4
984 lfsmake2 bison
985 lfsmake2 ncurses-compat
986 lfsmake2 ncurses
987 lfsmake2 procps
988 lfsmake2 libtool
989 lfsmake2 perl
990 lfsmake2 readline
991 lfsmake2 readline-compat
992 lfsmake2 bzip2
993 lfsmake2 pcre
994 lfsmake2 pcre-compat
995 lfsmake2 bash
996 lfsmake2 diffutils
997 lfsmake2 e2fsprogs
998 lfsmake2 ed
999 lfsmake2 findutils
1000 lfsmake2 flex
1001 lfsmake2 gawk
1002 lfsmake2 gettext
1003 lfsmake2 grep
1004 lfsmake2 groff
1005 lfsmake2 gperf
1006 lfsmake2 gzip
1007 lfsmake2 hostname
1008 lfsmake2 iproute2
1009 lfsmake2 jwhois
1010 lfsmake2 kbd
1011 lfsmake2 less
1012 lfsmake2 make
1013 lfsmake2 man
1014 lfsmake2 kmod
1015 lfsmake2 net-tools
1016 lfsmake2 patch
1017 lfsmake2 psmisc
1018 lfsmake2 shadow
1019 lfsmake2 sysklogd
1020 lfsmake2 sysvinit
1021 lfsmake2 tar
1022 lfsmake2 texinfo
1023 lfsmake2 util-linux
1024 lfsmake2 udev
1025 lfsmake2 vim
1026 lfsmake2 xz
1027 lfsmake2 paxctl
df5e82b3
MT
1028}
1029
15679d9f 1030buildipfire() {
907cd036 1031 LOGFILE="$BASEDIR/log/_build.ipfire.log"
df5e82b3 1032 export LOGFILE
489145db
MT
1033 lfsmake2 configroot
1034 lfsmake2 initscripts
1035 lfsmake2 backup
1036 lfsmake2 pkg-config
1037 lfsmake2 libusb
1038 lfsmake2 libusb-compat
1039 lfsmake2 libpcap
1040 lfsmake2 ppp
1041 lfsmake2 pptp
1042 lfsmake2 unzip
1043 lfsmake2 which
1044 lfsmake2 linux-firmware
1045 lfsmake2 ath10k-firmware
1046 lfsmake2 dvb-firmwares
1047 lfsmake2 mt7601u-firmware
1048 lfsmake2 zd1211-firmware
1049 lfsmake2 rpi-firmware
1050 lfsmake2 bc
1051 lfsmake2 u-boot
1052 lfsmake2 cpio
1053 lfsmake2 mdadm
1054 lfsmake2 dracut
1055 lfsmake2 lvm2
1056 lfsmake2 multipath-tools
1057 lfsmake2 freetype
1058 lfsmake2 grub
1059 lfsmake2 libmnl
1060 lfsmake2 libnfnetlink
1061 lfsmake2 libnetfilter_queue
1062 lfsmake2 libnetfilter_conntrack
1063 lfsmake2 libnetfilter_cthelper
1064 lfsmake2 libnetfilter_cttimeout
1065 lfsmake2 iptables
8e6fb99d 1066
dc7d6b20 1067 case "${BUILD_ARCH}" in
fc155193 1068 x86_64)
489145db
MT
1069 lfsmake2 linux KCFG=""
1070 lfsmake2 backports KCFG=""
1071 lfsmake2 e1000e KCFG=""
1072 lfsmake2 igb KCFG=""
1073 lfsmake2 ixgbe KCFG=""
1074 lfsmake2 xtables-addons KCFG=""
1075 lfsmake2 linux-initrd KCFG=""
fc155193 1076 ;;
3d02c091
MT
1077 i586)
1078 # x86-pae (Native and new XEN) kernel build
489145db
MT
1079 lfsmake2 linux KCFG="-pae"
1080 lfsmake2 backports KCFG="-pae"
1081 lfsmake2 e1000e KCFG="-pae"
1082 lfsmake2 igb KCFG="-pae"
1083 lfsmake2 ixgbe KCFG="-pae"
1084 lfsmake2 xtables-addons KCFG="-pae"
1085 lfsmake2 linux-initrd KCFG="-pae"
3d02c091
MT
1086
1087 # x86 kernel build
489145db
MT
1088 lfsmake2 linux KCFG=""
1089 lfsmake2 backports KCFG=""
1090 lfsmake2 e1000e KCFG=""
1091 lfsmake2 igb KCFG=""
1092 lfsmake2 ixgbe KCFG=""
1093 lfsmake2 xtables-addons KCFG=""
1094 lfsmake2 linux-initrd KCFG=""
3d02c091 1095 ;;
544f40d4 1096
3d02c091
MT
1097 armv5tel)
1098 # arm-rpi (Raspberry Pi) kernel build
489145db
MT
1099 lfsmake2 linux KCFG="-rpi"
1100 lfsmake2 backports KCFG="-rpi"
1101 lfsmake2 xtables-addons KCFG="-rpi"
1102 lfsmake2 linux-initrd KCFG="-rpi"
3d02c091
MT
1103
1104 # arm multi platform (Panda, Wandboard ...) kernel build
489145db
MT
1105 lfsmake2 linux KCFG="-multi"
1106 lfsmake2 backports KCFG="-multi"
1107 lfsmake2 e1000e KCFG="-multi"
1108 lfsmake2 igb KCFG="-multi"
1109 lfsmake2 ixgbe KCFG="-multi"
1110 lfsmake2 xtables-addons KCFG="-multi"
1111 lfsmake2 linux-initrd KCFG="-multi"
3d02c091
MT
1112
1113 # arm-kirkwood (Dreamplug, ICY-Box ...) kernel build
489145db
MT
1114 lfsmake2 linux KCFG="-kirkwood"
1115 lfsmake2 backports KCFG="-kirkwood"
1116 lfsmake2 e1000e KCFG="-kirkwood"
1117 lfsmake2 igb KCFG="-kirkwood"
1118 lfsmake2 ixgbe KCFG="-kirkwood"
1119 lfsmake2 xtables-addons KCFG="-kirkwood"
1120 lfsmake2 linux-initrd KCFG="-kirkwood"
3d02c091
MT
1121 ;;
1122 esac
489145db
MT
1123 lfsmake2 xtables-addons USPACE="1"
1124 lfsmake2 openssl
1125 [ "${BUILD_ARCH}" = "i586" ] && lfsmake2 openssl KCFG='-sse2'
1126 lfsmake2 libgpg-error
1127 lfsmake2 libgcrypt
1128 lfsmake2 libassuan
1129 lfsmake2 nettle
1130 lfsmake2 libevent
1131 lfsmake2 libevent2
89ad036a 1132 lfsmake2 libevent2-compat
489145db 1133 lfsmake2 expat
c8e9a7a8
WA
1134 lfsmake2 apr
1135 lfsmake2 aprutil
489145db
MT
1136 lfsmake2 unbound
1137 lfsmake2 gnutls
1138 lfsmake2 bind
1139 lfsmake2 dhcp
1140 lfsmake2 dhcpcd
1141 lfsmake2 boost
1142 lfsmake2 linux-atm
1143 lfsmake2 gdbm
1144 lfsmake2 pam
1145 lfsmake2 curl
1146 lfsmake2 tcl
1147 lfsmake2 sqlite
1148 lfsmake2 libffi
1149 lfsmake2 python
1150 lfsmake2 python3
1151 lfsmake2 ca-certificates
1152 lfsmake2 fireinfo
1153 lfsmake2 libnet
1154 lfsmake2 libnl
1155 lfsmake2 libnl-3
1156 lfsmake2 libidn
1157 lfsmake2 nasm
1158 lfsmake2 libjpeg
1159 lfsmake2 libjpeg-compat
1160 lfsmake2 libexif
1161 lfsmake2 libpng
1162 lfsmake2 libtiff
1163 lfsmake2 libart
1164 lfsmake2 gd
1165 lfsmake2 popt
489145db
MT
1166 lfsmake2 slang
1167 lfsmake2 newt
1168 lfsmake2 libsmooth
1169 lfsmake2 attr
1170 lfsmake2 acl
1171 lfsmake2 libcap
1172 lfsmake2 pciutils
1173 lfsmake2 usbutils
1174 lfsmake2 libxml2
1175 lfsmake2 libxslt
1176 lfsmake2 BerkeleyDB
1177 lfsmake2 mysql
1178 lfsmake2 cyrus-sasl
1179 lfsmake2 openldap
1180 lfsmake2 apache2
1181 lfsmake2 php
1182 lfsmake2 web-user-interface
1183 lfsmake2 flag-icons
1184 lfsmake2 jquery
6033b271 1185 lfsmake2 bootstrap
489145db
MT
1186 lfsmake2 arping
1187 lfsmake2 beep
1188 lfsmake2 dvdrtools
1189 lfsmake2 dosfstools
1190 lfsmake2 reiserfsprogs
1191 lfsmake2 xfsprogs
1192 lfsmake2 sysfsutils
1193 lfsmake2 fuse
1194 lfsmake2 ntfs-3g
1195 lfsmake2 ethtool
1196 lfsmake2 ez-ipupdate
1197 lfsmake2 fcron
1198 lfsmake2 perl-GD
1199 lfsmake2 GD-Graph
1200 lfsmake2 GD-TextUtil
1201 lfsmake2 perl-Device-SerialPort
1202 lfsmake2 perl-Device-Modem
1203 lfsmake2 perl-Apache-Htpasswd
1204 lfsmake2 gnupg
1205 lfsmake2 hdparm
1206 lfsmake2 sdparm
1207 lfsmake2 mtools
1208 lfsmake2 whatmask
1209 lfsmake2 conntrack-tools
1210 lfsmake2 libupnp
1211 lfsmake2 ipaddr
1212 lfsmake2 iputils
1213 lfsmake2 l7-protocols
1214 lfsmake2 mISDNuser
1215 lfsmake2 capi4k-utils
1216 lfsmake2 hwdata
1217 lfsmake2 logrotate
1218 lfsmake2 logwatch
1219 lfsmake2 misc-progs
1220 lfsmake2 nano
1221 lfsmake2 URI
1222 lfsmake2 HTML-Tagset
1223 lfsmake2 HTML-Parser
1224 lfsmake2 HTML-Template
1225 lfsmake2 Compress-Zlib
1226 lfsmake2 Digest
1227 lfsmake2 Digest-SHA1
1228 lfsmake2 Digest-HMAC
1229 lfsmake2 libwww-perl
1230 lfsmake2 Net-DNS
1231 lfsmake2 Net-IPv4Addr
1232 lfsmake2 Net_SSLeay
1233 lfsmake2 IO-Stringy
1234 lfsmake2 IO-Socket-SSL
1235 lfsmake2 Unix-Syslog
1236 lfsmake2 Mail-Tools
1237 lfsmake2 MIME-Tools
1238 lfsmake2 Net-Server
1239 lfsmake2 Convert-TNEF
1240 lfsmake2 Convert-UUlib
1241 lfsmake2 Archive-Tar
1242 lfsmake2 Archive-Zip
1243 lfsmake2 Text-Tabs+Wrap
1244 lfsmake2 Locale-Country
1245 lfsmake2 XML-Parser
1246 lfsmake2 Crypt-PasswdMD5
1247 lfsmake2 Net-Telnet
1248 lfsmake2 python-setuptools
1249 lfsmake2 python-clientform
1250 lfsmake2 python-mechanize
1251 lfsmake2 python-feedparser
1252 lfsmake2 python-rssdler
1253 lfsmake2 python-inotify
1254 lfsmake2 python-docutils
1255 lfsmake2 python-daemon
1256 lfsmake2 python-ipaddress
1257 lfsmake2 glib
1258 lfsmake2 GeoIP
489145db
MT
1259 lfsmake2 noip_updater
1260 lfsmake2 ntp
1261 lfsmake2 openssh
1262 lfsmake2 fontconfig
1263 lfsmake2 dejavu-fonts-ttf
70f6cba4 1264 lfsmake2 ubuntu-font-family
489145db
MT
1265 lfsmake2 freefont
1266 lfsmake2 pixman
1267 lfsmake2 cairo
1268 lfsmake2 pango
1269 lfsmake2 rrdtool
1270 lfsmake2 setserial
1271 lfsmake2 setup
1272 lfsmake2 libdnet
1273 lfsmake2 daq
1274 lfsmake2 snort
1275 lfsmake2 oinkmaster
1276 lfsmake2 squid
1277 lfsmake2 squidguard
1278 lfsmake2 calamaris
1279 lfsmake2 tcpdump
1280 lfsmake2 traceroute
1281 lfsmake2 vlan
1282 lfsmake2 wireless
1283 lfsmake2 pakfire
1284 lfsmake2 spandsp
1285 lfsmake2 lzo
1286 lfsmake2 openvpn
1287 lfsmake2 pammysql
1288 lfsmake2 mpage
1289 lfsmake2 dbus
1290 lfsmake2 intltool
1291 lfsmake2 libdaemon
1292 lfsmake2 cups
489145db 1293 lfsmake2 lcms2
56170c2a 1294 lfsmake2 ghostscript
489145db
MT
1295 lfsmake2 qpdf
1296 lfsmake2 poppler
1297 lfsmake2 cups-filters
1298 lfsmake2 epson-inkjet-printer-escpr
1299 lfsmake2 foomatic
1300 lfsmake2 hplip
1301 lfsmake2 cifs-utils
1302 lfsmake2 krb5
1303 lfsmake2 samba
1304 lfsmake2 sudo
1305 lfsmake2 mc
1306 lfsmake2 wget
1307 lfsmake2 bridge-utils
1308 lfsmake2 screen
1309 lfsmake2 smartmontools
1310 lfsmake2 htop
1311 lfsmake2 chkconfig
1312 lfsmake2 postfix
1313 lfsmake2 fetchmail
1314 lfsmake2 cyrus-imapd
1315 lfsmake2 openmailadmin
1316 lfsmake2 clamav
1317 lfsmake2 spamassassin
1318 lfsmake2 amavisd
1319 lfsmake2 dma
1320 lfsmake2 alsa
1321 lfsmake2 mpfire
1322 lfsmake2 guardian
1323 lfsmake2 libid3tag
1324 lfsmake2 libmad
1325 lfsmake2 libogg
1326 lfsmake2 libvorbis
1327 lfsmake2 libdvbpsi
1328 lfsmake2 flac
1329 lfsmake2 lame
1330 lfsmake2 sox
1331 lfsmake2 libshout
1332 lfsmake2 xvid
1333 lfsmake2 libmpeg2
1334 lfsmake2 libarchive
1335 lfsmake2 cmake
1336 lfsmake2 gnump3d
1337 lfsmake2 rsync
1338 lfsmake2 tcpwrapper
1339 lfsmake2 libtirpc
1340 lfsmake2 rpcbind
1341 lfsmake2 nfs
1342 lfsmake2 gnu-netcat
1343 lfsmake2 ncat
1344 lfsmake2 nmap
489145db
MT
1345 lfsmake2 etherwake
1346 lfsmake2 bwm-ng
1347 lfsmake2 sysstat
489145db
MT
1348 lfsmake2 strongswan
1349 lfsmake2 rng-tools
1350 lfsmake2 lsof
1351 lfsmake2 br2684ctl
1352 lfsmake2 pcmciautils
1353 lfsmake2 lm_sensors
1354 lfsmake2 liboping
1355 lfsmake2 collectd
1356 lfsmake2 elinks
1357 lfsmake2 igmpproxy
1358 lfsmake2 fbset
1359 lfsmake2 opus
1360 lfsmake2 python-six
1361 lfsmake2 python-pyparsing
1362 lfsmake2 spice-protocol
1363 lfsmake2 spice
1364 lfsmake2 sdl
1365 lfsmake2 libusbredir
1366 lfsmake2 qemu
1367 lfsmake2 sane
1368 lfsmake2 netpbm
1369 lfsmake2 phpSANE
1370 lfsmake2 tunctl
1371 lfsmake2 netsnmpd
1372 lfsmake2 nagios
1373 lfsmake2 nagios_nrpe
1374 lfsmake2 icinga
1375 lfsmake2 ebtables
1376 lfsmake2 directfb
489145db
MT
1377 lfsmake2 faad2
1378 lfsmake2 ffmpeg
1379 lfsmake2 vdr
1380 lfsmake2 vdr_streamdev
489145db
MT
1381 lfsmake2 vdr_epgsearch
1382 lfsmake2 vdr_dvbapi
1383 lfsmake2 vdr_eepg
1384 lfsmake2 w_scan
1385 lfsmake2 icecast
1386 lfsmake2 icegenerator
1387 lfsmake2 mpd
1388 lfsmake2 libmpdclient
1389 lfsmake2 mpc
1390 lfsmake2 perl-Net-SMTP-SSL
1391 lfsmake2 perl-MIME-Base64
1392 lfsmake2 perl-Authen-SASL
1393 lfsmake2 perl-MIME-Lite
1394 lfsmake2 perl-Email-Date-Format
1395 lfsmake2 git
1396 lfsmake2 squidclamav
1397 lfsmake2 vnstat
1398 lfsmake2 iw
1399 lfsmake2 wpa_supplicant
1400 lfsmake2 hostapd
1401 lfsmake2 pycurl
1402 lfsmake2 urlgrabber
1403 lfsmake2 syslinux
1404 lfsmake2 tftpd
1405 lfsmake2 cpufrequtils
1406 lfsmake2 bluetooth
1407 lfsmake2 gutenprint
1408 lfsmake2 apcupsd
1409 lfsmake2 iperf
1410 lfsmake2 iperf3
1411 lfsmake2 7zip
1412 lfsmake2 lynis
1413 lfsmake2 streamripper
1414 lfsmake2 sshfs
1415 lfsmake2 taglib
1416 #lfsmake2 mediatomb
1417 lfsmake2 sslh
1418 lfsmake2 perl-gettext
1419 lfsmake2 perl-Sort-Naturally
1420 lfsmake2 vdradmin
1421 lfsmake2 miau
1422 lfsmake2 perl-DBI
1423 lfsmake2 perl-DBD-mysql
1424 lfsmake2 perl-DBD-SQLite
1425 lfsmake2 perl-File-ReadBackwards
1426 lfsmake2 cacti
1427 lfsmake2 openvmtools
489145db
MT
1428 lfsmake2 motion
1429 lfsmake2 joe
1430 lfsmake2 monit
1431 lfsmake2 nut
1432 lfsmake2 watchdog
1433 lfsmake2 libpri
1434 lfsmake2 libsrtp
1435 lfsmake2 asterisk
1436 lfsmake2 lcr
1437 lfsmake2 usb_modeswitch
1438 lfsmake2 usb_modeswitch_data
1439 lfsmake2 zerofree
489145db
MT
1440 lfsmake2 minicom
1441 lfsmake2 ddrescue
489145db
MT
1442 lfsmake2 miniupnpd
1443 lfsmake2 client175
1444 lfsmake2 powertop
1445 lfsmake2 parted
1446 lfsmake2 swig
1447 lfsmake2 python-m2crypto
1448 lfsmake2 wireless-regdb
1449 lfsmake2 crda
1450 lfsmake2 libsolv
1451 lfsmake2 python-distutils-extra
1452 lfsmake2 python-lzma
1453 lfsmake2 python-progressbar
1454 lfsmake2 python-xattr
1455 lfsmake2 ddns
1456 lfsmake2 transmission
1457 lfsmake2 dpfhack
1458 lfsmake2 lcd4linux
1459 lfsmake2 mtr
489145db
MT
1460 lfsmake2 minidlna
1461 lfsmake2 acpid
1462 lfsmake2 fping
1463 lfsmake2 telnet
1464 lfsmake2 xinetd
1465 lfsmake2 gpgme
1466 lfsmake2 pygpgme
1467 lfsmake2 pakfire3
1468 lfsmake2 stress
1469 lfsmake2 libstatgrab
1470 lfsmake2 sarg
1471 lfsmake2 check_mk_agent
1472 lfsmake2 nginx
1473 lfsmake2 sendEmail
1474 lfsmake2 sysbench
1475 lfsmake2 strace
1476 lfsmake2 elfutils
1477 lfsmake2 ltrace
1478 lfsmake2 ipfire-netboot
1479 lfsmake2 lcdproc
1480 lfsmake2 bitstream
1481 lfsmake2 multicat
1482 lfsmake2 keepalived
1483 lfsmake2 ipvsadm
1484 lfsmake2 perl-Carp-Clan
1485 lfsmake2 perl-Date-Calc
1486 lfsmake2 perl-Date-Manip
1487 lfsmake2 perl-File-Tail
1488 lfsmake2 perl-TimeDate
1489 lfsmake2 swatch
1490 lfsmake2 tor
1491 lfsmake2 arm
1492 lfsmake2 wavemon
1493 lfsmake2 iptraf-ng
1494 lfsmake2 iotop
1495 lfsmake2 stunnel
489145db
MT
1496 lfsmake2 owncloud
1497 lfsmake2 bacula
1498 lfsmake2 batctl
b62c826f
MT
1499 lfsmake2 perl-Font-TTF
1500 lfsmake2 perl-IO-String
489145db
MT
1501 lfsmake2 perl-PDF-API2
1502 lfsmake2 squid-accounting
1503 lfsmake2 pigz
1504 lfsmake2 tmux
1505 lfsmake2 perl-Text-CSV_XS
1506 lfsmake2 swconfig
1507 lfsmake2 haproxy
1508 lfsmake2 ipset
1509 lfsmake2 lua
1510 lfsmake2 dnsdist
1511 lfsmake2 bird
1512 lfsmake2 dmidecode
1513 lfsmake2 mcelog
1514 lfsmake2 rtpproxy
1515 lfsmake2 util-macros
1516 lfsmake2 libpciaccess
1517 lfsmake2 libyajl
1518 lfsmake2 libvirt
b190cbe2 1519 lfsmake2 python3-libvirt
489145db
MT
1520 lfsmake2 freeradius
1521 lfsmake2 perl-common-sense
1522 lfsmake2 perl-inotify2
1523 lfsmake2 perl-Net-IP
0d6cc79d 1524 lfsmake2 wio
773caa66 1525 lfsmake2 iftop
d0817963 1526}
df5e82b3
MT
1527
1528buildinstaller() {
1529 # Run installer scripts one by one
1530 LOGFILE="$BASEDIR/log/_build.installer.log"
1531 export LOGFILE
489145db
MT
1532 lfsmake2 memtest
1533 lfsmake2 installer
ce9264a1
AF
1534 # use toolchain bash for chroot to strip
1535 EXTRA_PATH=${TOOLS_DIR}/bin/ lfsmake2 strip
df5e82b3
MT
1536}
1537
1538buildpackages() {
1539 LOGFILE="$BASEDIR/log/_build.packages.log"
1540 export LOGFILE
1541 echo "... see detailed log in _build.*.log files" >> $LOGFILE
0fbb45e9 1542
df5e82b3
MT
1543
1544 # Generating list of packages used
dc4ae0b7 1545 print_line "Generating packages list from logs"
df5e82b3
MT
1546 rm -f $BASEDIR/doc/packages-list
1547 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
1548 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
7471f6ab 1549 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
df5e82b3
MT
1550 fi
1551 done
7471f6ab 1552 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
4fe9acb2 1553 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$\|install1$\|install2$\|pass1$\|pass2$\|pass3$' \
df5e82b3
MT
1554 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
1555 rm -f $BASEDIR/doc/packages-list
c9673262 1556 # packages-list.txt is ready to be displayed for wiki page
f9783277 1557 print_status DONE
4b06f504
MT
1558
1559 # Update changelog
e49f7f0d 1560 cd $BASEDIR
c43b07fd
AF
1561 [ -z $GIT_TAG ] || LAST_TAG=$GIT_TAG
1562 [ -z $LAST_TAG ] || EXT="$LAST_TAG..HEAD"
1563 git log -n 500 --no-merges --pretty=medium --shortstat $EXT > $BASEDIR/doc/ChangeLog
df5e82b3 1564
9607771a 1565 # Create images for install
489145db 1566 lfsmake2 cdrom
bada0832 1567
4dc82852 1568 # Check if there is a loop device for building in virtual environments
841663e7
MT
1569 modprobe loop 2>/dev/null
1570 if [ $BUILD_IMAGES == 1 ] && ([ -e /dev/loop/0 ] || [ -e /dev/loop0 ] || [ -e "/dev/loop-control" ]); then
489145db
MT
1571 lfsmake2 flash-images
1572 lfsmake2 flash-images SCON=1
4dc82852 1573 fi
c9673262 1574
f0fc8807 1575 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz,*.bz2} $BASEDIR >> $LOGFILE 2>&1
c9673262 1576
0d909a4a 1577 ipfirepackages
e67a57fe 1578
489145db 1579 lfsmake2 xen-image
939c2a21 1580 mv $LFS/install/images/*.bz2 $BASEDIR >> $LOGFILE 2>&1
bada0832 1581
b307417f 1582 cd $BASEDIR
744a04ea
AF
1583
1584 # remove not useable iso on armv5tel (needed to build flash images)
dc7d6b20 1585 [ "${BUILD_ARCH}" = "armv5tel" ] && rm -rf *.iso
744a04ea 1586
b307417f
AF
1587 for i in `ls *.bz2 *.img.gz *.iso`; do
1588 md5sum $i > $i.md5
1589 done
1590 cd $PWD
1591
e67a57fe
MT
1592 # Cleanup
1593 stdumount
1594 rm -rf $BASEDIR/build/tmp/*
1595
e67a57fe 1596 cd $PWD
e67a57fe
MT
1597}
1598
1599ipfirepackages() {
489145db 1600 lfsmake2 core-updates
5596077b
MT
1601
1602 local i
dc7d6b20 1603 for i in $(find $BASEDIR/config/rootfiles/packages{/${BUILD_ARCH},} -maxdepth 1 -type f); do
5596077b 1604 i=$(basename ${i})
453b418b
MT
1605 if [ -e $BASEDIR/lfs/$i ]; then
1606 ipfiredist $i
1607 else
1608 echo -n $i
f9783277 1609 print_status SKIP
453b418b 1610 fi
fe7fe395 1611 done
78331e30 1612 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
5c8cfc99 1613 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
483f59cd 1614 rm -rf $BASEDIR/build/install/packages/*
df5e82b3
MT
1615}
1616
bcb9dc13
MT
1617while [ $# -gt 0 ]; do
1618 case "${1}" in
1619 --target=*)
c2e810de 1620 configure_build "${1#--target=}"
bcb9dc13
MT
1621 ;;
1622 -*)
1623 exiterror "Unknown configuration option: ${1}"
1624 ;;
1625 *)
1626 # Found a command, so exit options parsing.
1627 break
1628 ;;
1629 esac
1630 shift
1631done
1632
df5e82b3
MT
1633# See what we're supposed to do
1634case "$1" in
1635build)
f9783277
MT
1636 START_TIME=$(now)
1637
1638 # Clear screen
1639 ${INTERACTIVE} && clear
1640
f74072a2 1641 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz 2> /dev/null | head -n 1`
df5e82b3 1642 #only restore on a clean disk
6c4cc7ea 1643 if [ ! -e "${BASEDIR}/build${TOOLS_DIR}/.toolchain-successful" ]; then
df5e82b3 1644 if [ ! -n "$PACKAGE" ]; then
f9783277 1645 print_build_stage "Full toolchain compilation"
df5e82b3
MT
1646 prepareenv
1647 buildtoolchain
1648 else
f74072a2 1649 PACKAGENAME=${PACKAGE%.tar.xz}
f9783277 1650 print_build_stage "Packaged toolchain compilation"
df5e82b3 1651 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
f74072a2 1652 tar axf $PACKAGE
df5e82b3
MT
1653 prepareenv
1654 else
1655 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
1656 fi
1657 fi
1658 else
df5e82b3
MT
1659 prepareenv
1660 fi
5cfe86e6 1661
f9783277 1662 print_build_stage "Building LFS"
df5e82b3 1663 buildbase
15679d9f 1664
f9783277 1665 print_build_stage "Building IPFire"
15679d9f 1666 buildipfire
5cfe86e6 1667
f9783277 1668 print_build_stage "Building installer"
df5e82b3 1669 buildinstaller
15679d9f 1670
f9783277 1671 print_build_stage "Building packages"
df5e82b3 1672 buildpackages
7a5ed24e 1673
f9783277 1674 print_build_stage "Checking Logfiles for new Files"
b307417f
AF
1675
1676 cd $BASEDIR
7a5ed24e 1677 tools/checknewlog.pl
e0c923f4 1678 tools/checkrootfiles
b307417f 1679 cd $PWD
a23731d1 1680
f9783277 1681 print_build_summary $(( $(now) - ${START_TIME} ))
df5e82b3
MT
1682 ;;
1683shell)
1684 # enter a shell inside LFS chroot
1685 # may be used to changed kernel settings
1686 prepareenv
1687 entershell
1688 ;;
df5e82b3 1689clean)
f9783277
MT
1690 print_line "Cleaning build directory..."
1691
df5e82b3
MT
1692 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
1693 $LOSETUP -d $i 2>/dev/null
1694 done
1695 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
1696 umount $i
1697 done
1698 stdumount
1699 for i in `seq 0 7`; do
69a6ec55 1700 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
df5e82b3
MT
1701 umount /dev/loop${i} 2>/dev/null;
1702 losetup -d /dev/loop${i} 2>/dev/null;
69a6ec55 1703 fi;
df5e82b3
MT
1704 done
1705 rm -rf $BASEDIR/build
1706 rm -rf $BASEDIR/cdrom
f9315063 1707 rm -rf $BASEDIR/packages
df5e82b3 1708 rm -rf $BASEDIR/log
6c4cc7ea
MT
1709 if [ -h "${TOOLS_DIR}" ]; then
1710 rm -f "${TOOLS_DIR}"
df5e82b3 1711 fi
b307417f 1712 rm -f $BASEDIR/ipfire-*
f9783277 1713 print_status DONE
df5e82b3 1714 ;;
c3db995c 1715downloadsrc)
df5e82b3
MT
1716 if [ ! -d $BASEDIR/cache ]; then
1717 mkdir $BASEDIR/cache
1718 fi
1719 mkdir -p $BASEDIR/log
857d9bf2 1720 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
df5e82b3
MT
1721 FINISHED=0
1722 cd $BASEDIR/lfs
1723 for c in `seq $MAX_RETRIES`; do
1724 if (( FINISHED==1 )); then
1725 break
1726 fi
1727 FINISHED=1
1728 cd $BASEDIR/lfs
1729 for i in *; do
1730 if [ -f "$i" -a "$i" != "Config" ]; then
846e756e
MT
1731 lfsmakecommoncheck ${i} || continue
1732
dc7d6b20 1733 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1734 MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
df5e82b3 1735 if [ $? -ne 0 ]; then
f9783277 1736 print_status FAIL
df5e82b3
MT
1737 FINISHED=0
1738 else
1739 if [ $c -eq 1 ]; then
f9783277 1740 print_status DONE
df5e82b3
MT
1741 fi
1742 fi
1743 fi
1744 done
1745 done
e22c7973 1746 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
df5e82b3
MT
1747 ERROR=0
1748 for i in *; do
1749 if [ -f "$i" -a "$i" != "Config" ]; then
a4130265 1750 lfsmakecommoncheck ${i} > /dev/null || continue
dc7d6b20 1751 make -s -f $i LFS_BASEDIR=$BASEDIR BUILD_ARCH="${BUILD_ARCH}" \
51f9e7ac 1752 MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
df5e82b3 1753 if [ $? -ne 0 ]; then
e22c7973 1754 echo -ne "MD5 difference in lfs/$i"
f9783277 1755 print_status FAIL
df5e82b3
MT
1756 ERROR=1
1757 fi
1758 fi
1759 done
1760 if [ $ERROR -eq 0 ]; then
e22c7973 1761 echo -ne "${BOLD}all files md5sum match${NORMAL}"
f9783277 1762 print_status DONE
e22c7973
MT
1763 else
1764 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
f9783277 1765 print_status FAIL
df5e82b3 1766 fi
e22c7973 1767 cd - >/dev/null 2>&1
df5e82b3 1768 ;;
df5e82b3 1769toolchain)
f9783277
MT
1770 # Clear screen
1771 ${INTERACTIVE} && clear
1772
df5e82b3 1773 prepareenv
f3b7cf47 1774 print_build_stage "Toolchain compilation (${BUILD_ARCH})"
df5e82b3 1775 buildtoolchain
f74072a2 1776 echo "`date -u '+%b %e %T'`: Create toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
11104bfe 1777 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1778 cd $BASEDIR && XZ_OPT="-T0 -8" tar -Jc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
6c4cc7ea 1779 build/${TOOLS_DIR} build/bin/sh log >> $LOGFILE
f74072a2 1780 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.tar.xz \
dc7d6b20 1781 > cache/toolchains/$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}.md5
df5e82b3
MT
1782 stdumount
1783 ;;
1784gettoolchain)
df5e82b3 1785 # arbitrary name to be updated in case of new toolchain package upload
dc7d6b20 1786 PACKAGE=$SNAME-$VERSION-toolchain-$TOOLCHAINVER-${BUILD_ARCH}
f74072a2 1787 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.xz ]; then
5bd13f01 1788 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
11104bfe 1789 test -d $BASEDIR/cache/toolchains || mkdir -p $BASEDIR/cache/toolchains
f74072a2 1790 echo "`date -u '+%b %e %T'`: Load toolchain image for ${BUILD_ARCH}" | tee -a $LOGFILE
712d859c 1791 cd $BASEDIR/cache/toolchains
f74072a2 1792 wget -U "IPFireSourceGrabber/2.x" $URL_TOOLCHAIN/$PACKAGE.tar.xz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
712d859c 1793 if [ $? -ne 0 ]; then
dc7d6b20 1794 echo "`date -u '+%b %e %T'`: error downloading $PACKAGE toolchain for ${BUILD_ARCH} machine" | tee -a $LOGFILE
40a4ea4c 1795 else
f74072a2 1796 if [ "`md5sum $PACKAGE.tar.xz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
712d859c
MT
1797 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
1798 else
1799 exiterror "$PACKAGE.md5 did not match, check downloaded package"
1800 fi
40a4ea4c 1801 fi
712d859c
MT
1802 else
1803 echo "Toolchain is already downloaded. Exiting..."
df5e82b3
MT
1804 fi
1805 ;;
15679d9f
MT
1806uploadsrc)
1807 PWD=`pwd`
661d9388
CS
1808 if [ -z $IPFIRE_USER ]; then
1809 echo -n "You have to setup IPFIRE_USER first. See .config for details."
f9783277 1810 print_status FAIL
661d9388
CS
1811 exit 1
1812 fi
ae23a606 1813
661d9388 1814 URL_SOURCE=$(grep URL_SOURCE lfs/Config | awk '{ print $3 }')
15e38431 1815 REMOTE_FILES=$(echo "ls -1" | sftp -C ${IPFIRE_USER}@${URL_SOURCE})
661d9388 1816
15e38431
MT
1817 for file in ${BASEDIR}/cache/*; do
1818 [ -d "${file}" ] && continue
1819 grep -q "$(basename ${file})" <<<$REMOTE_FILES && continue
661d9388 1820 NEW_FILES="$NEW_FILES $file"
0eab8e84 1821 done
661d9388
CS
1822 [ -n "$NEW_FILES" ] && scp -2 $NEW_FILES ${IPFIRE_USER}@${URL_SOURCE}
1823 cd $BASEDIR
15679d9f
MT
1824 cd $PWD
1825 exit 0
0eab8e84 1826 ;;
bf7c473f 1827lang)
69a6ec55
MT
1828 echo -ne "Checking the translations for missing or obsolete strings..."
1829 chmod 755 $BASEDIR/tools/{check_strings.pl,sort_strings.pl,check_langs.sh}
1830 $BASEDIR/tools/sort_strings.pl en
1831 $BASEDIR/tools/sort_strings.pl de
1832 $BASEDIR/tools/sort_strings.pl fr
1833 $BASEDIR/tools/sort_strings.pl es
1834 $BASEDIR/tools/sort_strings.pl pl
1835 $BASEDIR/tools/sort_strings.pl ru
1836 $BASEDIR/tools/sort_strings.pl nl
1837 $BASEDIR/tools/sort_strings.pl tr
1838 $BASEDIR/tools/sort_strings.pl it
1839 $BASEDIR/tools/check_strings.pl en > $BASEDIR/doc/language_issues.en
1840 $BASEDIR/tools/check_strings.pl de > $BASEDIR/doc/language_issues.de
1841 $BASEDIR/tools/check_strings.pl fr > $BASEDIR/doc/language_issues.fr
1842 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.es
1843 $BASEDIR/tools/check_strings.pl es > $BASEDIR/doc/language_issues.pl
1844 $BASEDIR/tools/check_strings.pl ru > $BASEDIR/doc/language_issues.ru
1845 $BASEDIR/tools/check_strings.pl nl > $BASEDIR/doc/language_issues.nl
1846 $BASEDIR/tools/check_strings.pl tr > $BASEDIR/doc/language_issues.tr
1847 $BASEDIR/tools/check_strings.pl it > $BASEDIR/doc/language_issues.it
1848 $BASEDIR/tools/check_langs.sh > $BASEDIR/doc/language_missings
f9783277 1849 print_status DONE
69a6ec55
MT
1850
1851 echo -ne "Updating language lists..."
1852 update_language_list ${BASEDIR}/src/installer/po
1853 update_language_list ${BASEDIR}/src/setup/po
f9783277 1854 print_status DONE
bf7c473f 1855 ;;
6b8cff41 1856*)
a50d04ab 1857 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
6b8cff41
MT
1858 cat doc/make.sh-usage
1859 ;;
3ea75603 1860esac